//
//  CCIsometricEntity.h
//  CCIsometric
//
//  Created by Shotaro Emori on 12/02/18.
//  Copyright Shotaro Emori 2012. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "cocos2d.h"
#import "CCIsometricTile.h"

@interface CCIsometricEntity : CCNode<CCStandardTouchDelegate> {
@public
    ccIsoPoint tilePosition_;
    ccIsoSize tileSize_;
    BOOL draggable_;
    BOOL touchable_;
    BOOL isoMode_;
    ccIsoPoint lastPutTilePosition_;
@protected
    BOOL isTouch_;
    CGPoint movePoint_;
    NSMutableArray *touchArray_;
}

@property (assign, readwrite) ccIsoPoint tilePosition;
@property (assign, readwrite) ccIsoSize tileSize;
@property (assign, readonly) ccQuad2 quad;
@property (assign, readwrite) BOOL draggable;
@property (assign, readwrite) BOOL touchable;
@property (assign, readwrite) BOOL isoMode;
@property (assign, readonly) BOOL canPutEntity;
@property (assign, readonly) ccIsoPoint lastPutTilePosition;

#pragma mark - public method

- (BOOL)containsTouchLocation:(UITouch *)touch;
- (void)creanTileOnEntity;

#pragma mark - CCTargetedTouchDelegate

- (void)ccTouchesBegan:(NSSet *)touches withEvent:(UIEvent *)event;
- (void)ccTouchesMoved:(NSSet *)touches withEvent:(UIEvent *)event;
- (void)ccTouchesEnded:(NSSet *)touches withEvent:(UIEvent *)event;
- (void)ccTouchesCancelled:(NSSet *)touches withEvent:(UIEvent *)event;

@end
