//
//  CCIsometricLayer.h
//  CCIsometric
//
//  Created by Shotaro Emori on 12/02/18.
//  Copyright Shotaro Emori 2012. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "cocos2d.h"

@class CCIsometricEntity, CCIsometric;

@interface CCIsometricLayer : CCLayer
{
    @public
    CCIsometric *iso_;
    @private
    CGPoint movePoint1_;
    CGPoint movePoint2_;
    NSMutableArray *touchArray;
}

@property (retain, readonly) CCIsometric *iso;

#pragma mark - public method

- (id)initWithIso:(CCIsometric *)iso;

- (void)centerToPoint:(CGPoint)point scale:(float)scale callback:(CCCallFunc *)callback;
- (void)centerToPoint:(CGPoint)point duration:(float)duration scale:(float)scale callback:(CCCallFunc *)callback;
- (void)centerToEntity:(CCIsometricEntity *)entity scale:(float)scale callback:(CCCallFunc *)callback;
- (void)centerToEntity:(CCIsometricEntity *)entity duration:(float)duration scale:(float)scale callback:(CCCallFunc *)callback;

@end
