//
//  CCIsometricTile.h
//  CCIsometric
//
//  Created by Shotaro Emori on 12/02/18.
//  Copyright Shotaro Emori 2012. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "cocos2d.h"

typedef struct _ccIsoPoint {
    unsigned int x;
    unsigned int y;
} ccIsoPoint;

typedef struct _ccIsoSize {
    unsigned int width;
    unsigned int height;
} ccIsoSize;

@class CCIsometricEntity;

@interface CCIsometricTile : CCNode<CCStandardTouchDelegate>
{
    @public
    BOOL enable_;
    float size_;
    ccQuad2 quad_;
    float degrees_;
    ccIsoPoint tilePosition_;
    CGPoint layerSpacePosition_;
    BOOL isDrawLine_;
    BOOL isSelect_;
    ccColor4F lineColor_;
    ccColor4F selectColor_;
    CCIsometricEntity *onEntity_;
}

@property (assign, readwrite) BOOL enable;
@property (assign, readonly) float size;
@property (assign, readonly) ccQuad2 quad;
@property (assign, readonly) float degrees;
@property (assign, readwrite) ccIsoPoint tilePosition;
@property (assign, readonly) CGPoint layerSpacePosition;
@property (assign, readwrite) BOOL isDrawLine;
@property (assign, readwrite) BOOL isSelect;
@property (assign, readwrite) ccColor4F lineColor;
@property (assign, readwrite) ccColor4F selectColor;
@property (assign, readwrite) CCIsometricEntity *onEntity;

#pragma mark - static method

+ (CCIsometricTile *)tileWithSize:(float)size degrees:(float)degrees;

#pragma mark - public method

- (id)initWithSize:(float)size degrees:(float)degrees;

#pragma mark - CCStandardTouchDelegate

- (void) ccTouchesBegan:(NSSet *)touches withEvent:(UIEvent *)event;
- (void) ccTouchesMoved:(NSSet *)touches withEvent:(UIEvent *)event;
- (void) ccTouchesEnded:(NSSet *)touches withEvent:(UIEvent *)event;
- (void) ccTouchesCancelled:(NSSet *)touches withEvent:(UIEvent *)event;

@end
